//
//  CustomView.m
//
//  Code generated using QuartzCode 1.30.3 on 5/17/15.
//  www.quartzcodeapp.com
//

#import "CustomView.h"
#import "QCMethod.h"

@interface CustomView ()

@property (nonatomic, strong) NSMutableDictionary * layers;
@property (nonatomic, strong) NSMapTable * completionBlocks;
@property (nonatomic, assign) BOOL  updateLayerValueForCompletedAnimation;


@end

@implementation CustomView

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        [self setupProperties];
        [self setupLayers];
    }
    return self;
}

- (instancetype)initWithCoder:(NSCoder *)coder
{
    self = [super initWithCoder:coder];
    if (self) {
        [self setupProperties];
        [self setupLayers];
    }
    return self;
}

- (void)setFrame:(CGRect)frame{
    [super setFrame:frame];
    [self setupLayerFrames];
}

- (void)setBounds:(CGRect)bounds{
    [super setBounds:bounds];
    [self setupLayerFrames];
}

- (void)setupProperties{
    self.completionBlocks = [NSMapTable mapTableWithKeyOptions:NSPointerFunctionsOpaqueMemory valueOptions:NSPointerFunctionsStrongMemory];;
    self.layers = [NSMutableDictionary dictionary];
    self.cloudColor = [UIColor colorWithRed:0.373 green: 0.75 blue:0.93 alpha:1];
    self.lineColor = [UIColor blackColor];
}

- (void)setupLayers{
    CAShapeLayer * cloud = [CAShapeLayer layer];
    [self.layer addSublayer:cloud];
    self.layers[@"cloud"] = cloud;
    
    CAShapeLayer * cloud2 = [CAShapeLayer layer];
    [self.layer addSublayer:cloud2];
    self.layers[@"cloud2"] = cloud2;
    
    CAShapeLayer * cloud3 = [CAShapeLayer layer];
    [self.layer addSublayer:cloud3];
    self.layers[@"cloud3"] = cloud3;
    
    CAShapeLayer * cloud4 = [CAShapeLayer layer];
    [self.layer addSublayer:cloud4];
    self.layers[@"cloud4"] = cloud4;
    
    [self setupLayerFrames];
    [self resetLayerPropertiesForLayerIdentifiers:nil];
}

- (void)resetLayerPropertiesForLayerIdentifiers:(NSArray *)layerIds{
    [CATransaction begin];
    [CATransaction setDisableActions:YES];
    
    if(!layerIds || [layerIds containsObject:@"cloud"]){
        CAShapeLayer * cloud = self.layers[@"cloud"];
        cloud.anchorPoint   = CGPointMake(0.6, 0.5);
        cloud.fillColor     = nil;
        cloud.strokeColor   = self.lineColor.CGColor;
        cloud.lineWidth     = 3;
        cloud.strokeEnd     = 0;
        cloud.lineDashPhase = 1.5;
    }
    if(!layerIds || [layerIds containsObject:@"cloud2"]){
        CAShapeLayer * cloud2 = self.layers[@"cloud2"];
        cloud2.anchorPoint   = CGPointMake(0.6, 0.5);
        cloud2.fillColor     = nil;
        cloud2.strokeColor   = self.lineColor.CGColor;
        cloud2.lineWidth     = 3;
        cloud2.strokeStart   = 1;
        cloud2.shadowColor   = [UIColor colorWithRed:0 green: 0 blue:0 alpha:0.333].CGColor;
        cloud2.shadowOpacity = 0.33;
        cloud2.shadowOffset  = CGSizeMake(4, 4);
        cloud2.shadowRadius  = 5;
    }
    if(!layerIds || [layerIds containsObject:@"cloud3"]){
        CAShapeLayer * cloud3 = self.layers[@"cloud3"];
        cloud3.fillColor   = [UIColor whiteColor].CGColor;
        cloud3.strokeColor = self.lineColor.CGColor;
        cloud3.lineWidth   = 3;
        cloud3.strokeStart = 1;
    }
    if(!layerIds || [layerIds containsObject:@"cloud4"]){
        CAShapeLayer * cloud4 = self.layers[@"cloud4"];
        cloud4.lineJoin    = kCALineJoinRound;
        cloud4.fillColor   = nil;
        cloud4.strokeColor = self.lineColor.CGColor;
        cloud4.lineWidth   = 3;
        cloud4.strokeEnd   = 0;
    }
    
    [CATransaction commit];
}

- (void)setupLayerFrames{
    CAShapeLayer * cloud  = self.layers[@"cloud"];
    cloud.frame           = CGRectMake(0.05825 * CGRectGetWidth(cloud.superlayer.bounds), 0.1869 * CGRectGetHeight(cloud.superlayer.bounds), 0.72727 * CGRectGetWidth(cloud.superlayer.bounds), 0.50673 * CGRectGetHeight(cloud.superlayer.bounds));
    cloud.path            = [self cloudPathWithBounds:cloud.bounds].CGPath;
    
    CAShapeLayer * cloud2 = self.layers[@"cloud2"];
    cloud2.frame          = CGRectMake(0.05599 * CGRectGetWidth(cloud2.superlayer.bounds), 0.18463 * CGRectGetHeight(cloud2.superlayer.bounds), 0.72727 * CGRectGetWidth(cloud2.superlayer.bounds), 0.50673 * CGRectGetHeight(cloud2.superlayer.bounds));
    cloud2.path           = [self cloud2PathWithBounds:cloud2.bounds].CGPath;
    
    CAShapeLayer * cloud3 = self.layers[@"cloud3"];
    cloud3.frame          = CGRectMake(0.21667 * CGRectGetWidth(cloud3.superlayer.bounds), 0.30864 * CGRectGetHeight(cloud3.superlayer.bounds), 0.72727 * CGRectGetWidth(cloud3.superlayer.bounds), 0.50673 * CGRectGetHeight(cloud3.superlayer.bounds));
    cloud3.path           = [self cloud3PathWithBounds:cloud3.bounds].CGPath;
    
    CAShapeLayer * cloud4 = self.layers[@"cloud4"];
    cloud4.frame          = CGRectMake(0.21674 * CGRectGetWidth(cloud4.superlayer.bounds), 0.3085 * CGRectGetHeight(cloud4.superlayer.bounds), 0.72727 * CGRectGetWidth(cloud4.superlayer.bounds), 0.50673 * CGRectGetHeight(cloud4.superlayer.bounds));
    cloud4.path           = [self cloud4PathWithBounds:cloud4.bounds].CGPath;
    
}

- (void)addShowAnimation{
    [self addShowAnimationCompletionBlock:nil];
}

- (void)addShowAnimationCompletionBlock:(void (^)(BOOL finished))completionBlock{
    [self addShowAnimationReverse:NO totalDuration:4.416 endTime:1 completionBlock:completionBlock];
}

- (void)addShowAnimationReverse:(BOOL)reverseAnimation totalDuration:(CFTimeInterval)totalDuration endTime:(CFTimeInterval)endTime completionBlock:(void (^)(BOOL finished))completionBlock{
    endTime = endTime * totalDuration;
    
    if (completionBlock){
        CABasicAnimation * completionAnim = [CABasicAnimation animationWithKeyPath:@"completionAnim"];;
        completionAnim.duration = endTime;
        completionAnim.delegate = self;
        [completionAnim setValue:@"show" forKey:@"animId"];
        [completionAnim setValue:@(YES) forKey:@"needEndAnim"];
        [self.layer addAnimation:completionAnim forKey:@"show"];
        [self.completionBlocks setObject:completionBlock forKey:[self.layer animationForKey:@"show"]];
    }
    
    NSString * fillMode = reverseAnimation ? kCAFillModeBoth : kCAFillModeForwards;
    
    ////Cloud animation
    
    CABasicAnimation * cloudStrokeEndAnim = [CABasicAnimation animationWithKeyPath:@"strokeEnd"];
    cloudStrokeEndAnim.fromValue          = @0;
    cloudStrokeEndAnim.toValue            = @1;
    cloudStrokeEndAnim.duration           = 0.453 * totalDuration;
    cloudStrokeEndAnim.beginTime          = 0.38 * totalDuration;
    cloudStrokeEndAnim.timingFunction     = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionDefault];
    
    CAAnimationGroup * cloudShowAnim = [QCMethod groupAnimations:@[cloudStrokeEndAnim] fillMode:fillMode];
    if (reverseAnimation) cloudShowAnim = (CAAnimationGroup *)[QCMethod reverseAnimation:cloudShowAnim totalDuration:totalDuration];
    [self.layers[@"cloud"] addAnimation:cloudShowAnim forKey:@"cloudShowAnim"];
    
    ////Cloud2 animation
    
    CABasicAnimation * cloud2StrokeStartAnim = [CABasicAnimation animationWithKeyPath:@"strokeStart"];
    cloud2StrokeStartAnim.fromValue      = @0.7;
    cloud2StrokeStartAnim.toValue        = @0;
    cloud2StrokeStartAnim.duration       = 0.453 * totalDuration;
    cloud2StrokeStartAnim.beginTime      = 0.354 * totalDuration;
    cloud2StrokeStartAnim.timingFunction = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionDefault];
    
    CABasicAnimation * cloud2FillColorAnim = [CABasicAnimation animationWithKeyPath:@"fillColor"];
    cloud2FillColorAnim.fromValue          = (id)[UIColor colorWithRed:0.111 green: 0.08 blue:0.915 alpha:0].CGColor;
    cloud2FillColorAnim.toValue            = (id)self.cloudColor.CGColor;
    cloud2FillColorAnim.duration           = 0.176 * totalDuration;
    cloud2FillColorAnim.beginTime          = 0.574 * totalDuration;
    cloud2FillColorAnim.timingFunction     = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionDefault];
    
    CAKeyframeAnimation * cloud2StrokeColorAnim = [CAKeyframeAnimation animationWithKeyPath:@"strokeColor"];
    cloud2StrokeColorAnim.values    = @[(id)self.lineColor.CGColor,
                                        (id)self.lineColor.CGColor];
    cloud2StrokeColorAnim.keyTimes  = @[@0, @1];
    cloud2StrokeColorAnim.duration  = 0.226 * totalDuration;
    cloud2StrokeColorAnim.beginTime = 0.75 * totalDuration;
    
    CAKeyframeAnimation * cloud2OpacityAnim = [CAKeyframeAnimation animationWithKeyPath:@"opacity"];
    cloud2OpacityAnim.values    = @[@1, @1];
    cloud2OpacityAnim.keyTimes  = @[@0, @1];
    cloud2OpacityAnim.duration  = 0.226 * totalDuration;
    cloud2OpacityAnim.beginTime = 0.75 * totalDuration;
    
    CAAnimationGroup * cloud2ShowAnim = [QCMethod groupAnimations:@[cloud2StrokeStartAnim, cloud2FillColorAnim, cloud2StrokeColorAnim, cloud2OpacityAnim] fillMode:fillMode];
    if (reverseAnimation) cloud2ShowAnim = (CAAnimationGroup *)[QCMethod reverseAnimation:cloud2ShowAnim totalDuration:totalDuration];
    [self.layers[@"cloud2"] addAnimation:cloud2ShowAnim forKey:@"cloud2ShowAnim"];
    
    ////Cloud3 animation
    
    CABasicAnimation * cloud3StrokeStartAnim = [CABasicAnimation animationWithKeyPath:@"strokeStart"];
    cloud3StrokeStartAnim.fromValue      = @1;
    cloud3StrokeStartAnim.toValue        = @0;
    cloud3StrokeStartAnim.duration       = 0.408 * totalDuration;
    cloud3StrokeStartAnim.timingFunction = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseIn];
    
    CAAnimationGroup * cloud3ShowAnim = [QCMethod groupAnimations:@[cloud3StrokeStartAnim] fillMode:fillMode];
    if (reverseAnimation) cloud3ShowAnim = (CAAnimationGroup *)[QCMethod reverseAnimation:cloud3ShowAnim totalDuration:totalDuration];
    [self.layers[@"cloud3"] addAnimation:cloud3ShowAnim forKey:@"cloud3ShowAnim"];
    
    ////Cloud4 animation
    
    CABasicAnimation * cloud4StrokeEndAnim = [CABasicAnimation animationWithKeyPath:@"strokeEnd"];
    cloud4StrokeEndAnim.fromValue          = @0;
    cloud4StrokeEndAnim.toValue            = @1;
    cloud4StrokeEndAnim.duration           = 0.408 * totalDuration;
    cloud4StrokeEndAnim.timingFunction     = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseIn];
    
    CABasicAnimation * cloud4FillColorAnim = [CABasicAnimation animationWithKeyPath:@"fillColor"];
    cloud4FillColorAnim.fromValue          = (id)[UIColor colorWithRed:1 green: 1 blue:1 alpha:0].CGColor;
    cloud4FillColorAnim.toValue            = (id)self.cloudColor.CGColor;
    cloud4FillColorAnim.duration           = 0.453 * totalDuration;
    cloud4FillColorAnim.beginTime          = 0.282 * totalDuration;
    cloud4FillColorAnim.timingFunction     = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionDefault];
    
    CAKeyframeAnimation * cloud4ShadowColorAnim = [CAKeyframeAnimation animationWithKeyPath:@"shadowColor"];
    cloud4ShadowColorAnim.values           = @[(id)[UIColor blackColor].CGColor,
                                               (id)[UIColor blackColor].CGColor,
                                               (id)[UIColor colorWithRed:0.451 green: 0.451 blue:0.451 alpha:1].CGColor];
    cloud4ShadowColorAnim.duration         = 0.366 * totalDuration;
    cloud4ShadowColorAnim.beginTime        = 0.634 * totalDuration;
    cloud4ShadowColorAnim.timingFunction   = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseOut];
    CAKeyframeAnimation * cloud4ShadowOpacityAnim = [CAKeyframeAnimation animationWithKeyPath:@"shadowOpacity"];
    cloud4ShadowOpacityAnim.values         = @[@0.216, @0.34, @0.601];
    cloud4ShadowOpacityAnim.duration       = 0.366 * totalDuration;
    cloud4ShadowOpacityAnim.beginTime      = 0.634 * totalDuration;
    cloud4ShadowOpacityAnim.timingFunction = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseOut];
    CAKeyframeAnimation * cloud4ShadowOffsetAnim = [CAKeyframeAnimation animationWithKeyPath:@"shadowOffset"];
    cloud4ShadowOffsetAnim.values          = @[[NSValue valueWithCGSize:CGSizeMake(0, 3)],
                                               [NSValue valueWithCGSize:CGSizeMake(0, 10)],
                                               [NSValue valueWithCGSize:CGSizeMake(8, 12)]];
    cloud4ShadowOffsetAnim.duration        = 0.366 * totalDuration;
    cloud4ShadowOffsetAnim.beginTime       = 0.634 * totalDuration;
    cloud4ShadowOffsetAnim.timingFunction  = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseOut];
    
    CAAnimationGroup * cloud4ShowAnim = [QCMethod groupAnimations:@[cloud4StrokeEndAnim, cloud4FillColorAnim, cloud4ShadowColorAnim, cloud4ShadowOpacityAnim, cloud4ShadowOffsetAnim] fillMode:fillMode];
    if (reverseAnimation) cloud4ShowAnim = (CAAnimationGroup *)[QCMethod reverseAnimation:cloud4ShowAnim totalDuration:totalDuration];
    [self.layers[@"cloud4"] addAnimation:cloud4ShowAnim forKey:@"cloud4ShowAnim"];
}

- (void)animationDidStop:(CAAnimation *)anim finished:(BOOL)flag{
    void (^completionBlock)(BOOL) = [self.completionBlocks objectForKey:anim];;
    if (completionBlock){
        [self.completionBlocks removeObjectForKey:anim];
        if ((flag && self.updateLayerValueForCompletedAnimation) || [[anim valueForKey:@"needEndAnim"] boolValue]){
            [self updateLayerValuesForAnimationId:[anim valueForKey:@"animId"]];
            [self removeAnimationsForAnimationId:[anim valueForKey:@"animId"]];
        }
        completionBlock(flag);
    }
}

- (void)updateLayerValuesForAnimationId:(NSString *)identifier{
    if([identifier isEqualToString:@"show"]){
        [QCMethod updateValueFromPresentationLayerForAnimation:[self.layers[@"cloud"] animationForKey:@"cloudShowAnim"] theLayer:self.layers[@"cloud"]];
        [QCMethod updateValueFromPresentationLayerForAnimation:[self.layers[@"cloud2"] animationForKey:@"cloud2ShowAnim"] theLayer:self.layers[@"cloud2"]];
        [QCMethod updateValueFromPresentationLayerForAnimation:[self.layers[@"cloud3"] animationForKey:@"cloud3ShowAnim"] theLayer:self.layers[@"cloud3"]];
        [QCMethod updateValueFromPresentationLayerForAnimation:[self.layers[@"cloud4"] animationForKey:@"cloud4ShowAnim"] theLayer:self.layers[@"cloud4"]];
    }
}

- (void)removeAnimationsForAnimationId:(NSString *)identifier{
    if([identifier isEqualToString:@"show"]){
        [self.layers[@"cloud"] removeAnimationForKey:@"cloudShowAnim"];
        [self.layers[@"cloud2"] removeAnimationForKey:@"cloud2ShowAnim"];
        [self.layers[@"cloud3"] removeAnimationForKey:@"cloud3ShowAnim"];
        [self.layers[@"cloud4"] removeAnimationForKey:@"cloud4ShowAnim"];
    }
}

#pragma mark - Bezier Path

- (UIBezierPath*)cloudPathWithBounds:(CGRect)bound{
    UIBezierPath *cloudPath = [UIBezierPath bezierPath];
    CGFloat minX = CGRectGetMinX(bound), minY = CGRectGetMinY(bound), w = CGRectGetWidth(bound), h = CGRectGetHeight(bound);
    
    [cloudPath moveToPoint:CGPointMake(minX + 0.874 * w, minY + 0.4503 * h)];
    [cloudPath addLineToPoint:CGPointMake(minX + 0.874 * w, minY + 0.43595 * h)];
    [cloudPath addCurveToPoint:CGPointMake(minX + 0.874 * w, minY + 0.3685 * h) controlPoint1:CGPointMake(minX + 0.874 * w, minY + 0.43595 * h) controlPoint2:CGPointMake(minX + 0.874 * w, minY + 0.43308 * h)];
    [cloudPath addCurveToPoint:CGPointMake(minX + 0.634 * w, minY + 0.00538 * h) controlPoint1:CGPointMake(minX + 0.874 * w, minY + 0.30391 * h) controlPoint2:CGPointMake(minX + 0.85 * w, minY + 0.04844 * h)];
    [cloudPath addCurveToPoint:CGPointMake(minX + 0.347 * w, minY + 0.20631 * h) controlPoint1:CGPointMake(minX + 0.444 * w, minY + -0.03194 * h) controlPoint2:CGPointMake(minX + 0.362 * w, minY + 0.13455 * h)];
    [cloudPath addCurveToPoint:CGPointMake(minX + 0.122 * w, minY + 0.49049 * h) controlPoint1:CGPointMake(minX + 0.347 * w, minY + 0.20631 * h) controlPoint2:CGPointMake(minX + 0.11 * w, minY + 0.14603 * h)];
    [cloudPath addCurveToPoint:CGPointMake(minX, minY + 0.73735 * h) controlPoint1:CGPointMake(minX + 0.122 * w, minY + 0.49049 * h) controlPoint2:CGPointMake(minX, minY + 0.5766 * h)];
    [cloudPath addCurveToPoint:CGPointMake(minX + 0.173 * w, minY + h) controlPoint1:CGPointMake(minX, minY + 0.89953 * h) controlPoint2:CGPointMake(minX + 0.077 * w, minY + h)];
    [cloudPath addCurveToPoint:CGPointMake(minX + 0.85 * w, minY + h) controlPoint1:CGPointMake(minX + 0.269 * w, minY + h) controlPoint2:CGPointMake(minX + 0.805 * w, minY + h)];
    [cloudPath addCurveToPoint:CGPointMake(minX + w, minY + 0.74166 * h) controlPoint1:CGPointMake(minX + 0.895 * w, minY + h) controlPoint2:CGPointMake(minX + w, minY + 0.89953 * h)];
    [cloudPath addCurveToPoint:CGPointMake(minX + 0.874 * w, minY + 0.4503 * h) controlPoint1:CGPointMake(minX + w, minY + 0.58378 * h) controlPoint2:CGPointMake(minX + 0.929 * w, minY + 0.49336 * h)];
    [cloudPath closePath];
    [cloudPath moveToPoint:CGPointMake(minX + 0.874 * w, minY + 0.4503 * h)];
    
    return cloudPath;
}

- (UIBezierPath*)cloud2PathWithBounds:(CGRect)bound{
    UIBezierPath *cloud2Path = [UIBezierPath bezierPath];
    CGFloat minX = CGRectGetMinX(bound), minY = CGRectGetMinY(bound), w = CGRectGetWidth(bound), h = CGRectGetHeight(bound);
    
    [cloud2Path moveToPoint:CGPointMake(minX + 0.874 * w, minY + 0.4503 * h)];
    [cloud2Path addLineToPoint:CGPointMake(minX + 0.874 * w, minY + 0.43595 * h)];
    [cloud2Path addCurveToPoint:CGPointMake(minX + 0.874 * w, minY + 0.3685 * h) controlPoint1:CGPointMake(minX + 0.874 * w, minY + 0.43595 * h) controlPoint2:CGPointMake(minX + 0.874 * w, minY + 0.43308 * h)];
    [cloud2Path addCurveToPoint:CGPointMake(minX + 0.634 * w, minY + 0.00538 * h) controlPoint1:CGPointMake(minX + 0.874 * w, minY + 0.30391 * h) controlPoint2:CGPointMake(minX + 0.85 * w, minY + 0.04844 * h)];
    [cloud2Path addCurveToPoint:CGPointMake(minX + 0.347 * w, minY + 0.20631 * h) controlPoint1:CGPointMake(minX + 0.444 * w, minY + -0.03194 * h) controlPoint2:CGPointMake(minX + 0.362 * w, minY + 0.13455 * h)];
    [cloud2Path addCurveToPoint:CGPointMake(minX + 0.122 * w, minY + 0.49049 * h) controlPoint1:CGPointMake(minX + 0.347 * w, minY + 0.20631 * h) controlPoint2:CGPointMake(minX + 0.11 * w, minY + 0.14603 * h)];
    [cloud2Path addCurveToPoint:CGPointMake(minX, minY + 0.73735 * h) controlPoint1:CGPointMake(minX + 0.122 * w, minY + 0.49049 * h) controlPoint2:CGPointMake(minX, minY + 0.5766 * h)];
    [cloud2Path addCurveToPoint:CGPointMake(minX + 0.173 * w, minY + h) controlPoint1:CGPointMake(minX, minY + 0.89953 * h) controlPoint2:CGPointMake(minX + 0.077 * w, minY + h)];
    [cloud2Path addCurveToPoint:CGPointMake(minX + 0.85 * w, minY + h) controlPoint1:CGPointMake(minX + 0.269 * w, minY + h) controlPoint2:CGPointMake(minX + 0.805 * w, minY + h)];
    [cloud2Path addCurveToPoint:CGPointMake(minX + w, minY + 0.74166 * h) controlPoint1:CGPointMake(minX + 0.895 * w, minY + h) controlPoint2:CGPointMake(minX + w, minY + 0.89953 * h)];
    [cloud2Path addCurveToPoint:CGPointMake(minX + 0.874 * w, minY + 0.4503 * h) controlPoint1:CGPointMake(minX + w, minY + 0.58378 * h) controlPoint2:CGPointMake(minX + 0.929 * w, minY + 0.49336 * h)];
    [cloud2Path closePath];
    [cloud2Path moveToPoint:CGPointMake(minX + 0.874 * w, minY + 0.4503 * h)];
    
    return cloud2Path;
}

- (UIBezierPath*)cloud3PathWithBounds:(CGRect)bound{
    UIBezierPath *cloud3Path = [UIBezierPath bezierPath];
    CGFloat minX = CGRectGetMinX(bound), minY = CGRectGetMinY(bound), w = CGRectGetWidth(bound), h = CGRectGetHeight(bound);
    
    [cloud3Path moveToPoint:CGPointMake(minX + 0.126 * w, minY + 0.4503 * h)];
    [cloud3Path addLineToPoint:CGPointMake(minX + 0.126 * w, minY + 0.43595 * h)];
    [cloud3Path addCurveToPoint:CGPointMake(minX + 0.126 * w, minY + 0.3685 * h) controlPoint1:CGPointMake(minX + 0.126 * w, minY + 0.43595 * h) controlPoint2:CGPointMake(minX + 0.126 * w, minY + 0.43308 * h)];
    [cloud3Path addCurveToPoint:CGPointMake(minX + 0.366 * w, minY + 0.00538 * h) controlPoint1:CGPointMake(minX + 0.126 * w, minY + 0.30391 * h) controlPoint2:CGPointMake(minX + 0.15 * w, minY + 0.04844 * h)];
    [cloud3Path addCurveToPoint:CGPointMake(minX + 0.653 * w, minY + 0.20631 * h) controlPoint1:CGPointMake(minX + 0.556 * w, minY + -0.03194 * h) controlPoint2:CGPointMake(minX + 0.638 * w, minY + 0.13455 * h)];
    [cloud3Path addCurveToPoint:CGPointMake(minX + 0.878 * w, minY + 0.49049 * h) controlPoint1:CGPointMake(minX + 0.653 * w, minY + 0.20631 * h) controlPoint2:CGPointMake(minX + 0.89 * w, minY + 0.14603 * h)];
    [cloud3Path addCurveToPoint:CGPointMake(minX + w, minY + 0.73735 * h) controlPoint1:CGPointMake(minX + 0.878 * w, minY + 0.49049 * h) controlPoint2:CGPointMake(minX + w, minY + 0.5766 * h)];
    [cloud3Path addCurveToPoint:CGPointMake(minX + 0.827 * w, minY + h) controlPoint1:CGPointMake(minX + w, minY + 0.89953 * h) controlPoint2:CGPointMake(minX + 0.923 * w, minY + h)];
    [cloud3Path addCurveToPoint:CGPointMake(minX + 0.15 * w, minY + h) controlPoint1:CGPointMake(minX + 0.731 * w, minY + h) controlPoint2:CGPointMake(minX + 0.195 * w, minY + h)];
    [cloud3Path addCurveToPoint:CGPointMake(minX, minY + 0.74166 * h) controlPoint1:CGPointMake(minX + 0.105 * w, minY + h) controlPoint2:CGPointMake(minX, minY + 0.89953 * h)];
    [cloud3Path addCurveToPoint:CGPointMake(minX + 0.126 * w, minY + 0.4503 * h) controlPoint1:CGPointMake(minX, minY + 0.58378 * h) controlPoint2:CGPointMake(minX + 0.071 * w, minY + 0.49336 * h)];
    [cloud3Path closePath];
    [cloud3Path moveToPoint:CGPointMake(minX + 0.126 * w, minY + 0.4503 * h)];
    
    return cloud3Path;
}

- (UIBezierPath*)cloud4PathWithBounds:(CGRect)bound{
    UIBezierPath *cloud4Path = [UIBezierPath bezierPath];
    CGFloat minX = CGRectGetMinX(bound), minY = CGRectGetMinY(bound), w = CGRectGetWidth(bound), h = CGRectGetHeight(bound);
    
    [cloud4Path moveToPoint:CGPointMake(minX + 0.126 * w, minY + 0.4503 * h)];
    [cloud4Path addLineToPoint:CGPointMake(minX + 0.126 * w, minY + 0.43595 * h)];
    [cloud4Path addCurveToPoint:CGPointMake(minX + 0.126 * w, minY + 0.3685 * h) controlPoint1:CGPointMake(minX + 0.126 * w, minY + 0.43595 * h) controlPoint2:CGPointMake(minX + 0.126 * w, minY + 0.43308 * h)];
    [cloud4Path addCurveToPoint:CGPointMake(minX + 0.366 * w, minY + 0.00538 * h) controlPoint1:CGPointMake(minX + 0.126 * w, minY + 0.30391 * h) controlPoint2:CGPointMake(minX + 0.15 * w, minY + 0.04844 * h)];
    [cloud4Path addCurveToPoint:CGPointMake(minX + 0.653 * w, minY + 0.20631 * h) controlPoint1:CGPointMake(minX + 0.556 * w, minY + -0.03194 * h) controlPoint2:CGPointMake(minX + 0.638 * w, minY + 0.13455 * h)];
    [cloud4Path addCurveToPoint:CGPointMake(minX + 0.878 * w, minY + 0.49049 * h) controlPoint1:CGPointMake(minX + 0.653 * w, minY + 0.20631 * h) controlPoint2:CGPointMake(minX + 0.89 * w, minY + 0.14603 * h)];
    [cloud4Path addCurveToPoint:CGPointMake(minX + w, minY + 0.73735 * h) controlPoint1:CGPointMake(minX + 0.878 * w, minY + 0.49049 * h) controlPoint2:CGPointMake(minX + w, minY + 0.5766 * h)];
    [cloud4Path addCurveToPoint:CGPointMake(minX + 0.827 * w, minY + h) controlPoint1:CGPointMake(minX + w, minY + 0.89953 * h) controlPoint2:CGPointMake(minX + 0.923 * w, minY + h)];
    [cloud4Path addCurveToPoint:CGPointMake(minX + 0.15 * w, minY + h) controlPoint1:CGPointMake(minX + 0.731 * w, minY + h) controlPoint2:CGPointMake(minX + 0.195 * w, minY + h)];
    [cloud4Path addCurveToPoint:CGPointMake(minX, minY + 0.74166 * h) controlPoint1:CGPointMake(minX + 0.105 * w, minY + h) controlPoint2:CGPointMake(minX, minY + 0.89953 * h)];
    [cloud4Path addCurveToPoint:CGPointMake(minX + 0.126 * w, minY + 0.4503 * h) controlPoint1:CGPointMake(minX, minY + 0.58378 * h) controlPoint2:CGPointMake(minX + 0.071 * w, minY + 0.49336 * h)];
    [cloud4Path closePath];
    [cloud4Path moveToPoint:CGPointMake(minX + 0.126 * w, minY + 0.4503 * h)];
    
    return cloud4Path;
}


@end