//
//  CustomView.swift
//
//  Code generated using QuartzCode 1.50.0 on 26/09/2016.
//  www.quartzcodeapp.com
//

import UIKit


class CustomView: UIView, CAAnimationDelegate {
    
    var updateLayerValueForCompletedAnimation : Bool = false
    var animationAdded : Bool = false
    var completionBlocks : Dictionary<CAAnimation, (Bool) -> Void> = [:]
    var layers : Dictionary<String, AnyObject> = [:]
    
    
    
    //MARK: - Life Cycle
    
    override init(frame: CGRect) {
        super.init(frame: frame)
        setupProperties()
        setupLayers()
    }
    
    required init?(coder aDecoder: NSCoder)
    {
        super.init(coder: aDecoder)
        setupProperties()
        setupLayers()
    }
    
    var oldAnimProgress: CGFloat = 0{
        didSet{
            if(!self.animationAdded){
                removeAllAnimations()
                addOldAnimation()
                self.animationAdded = true
                layer.speed = 0
                layer.timeOffset = 0
            }
            else{
                let totalDuration : CGFloat = 4.42
                let offset = oldAnimProgress * totalDuration
                layer.timeOffset = CFTimeInterval(offset)
            }
        }
    }
    
    override var frame: CGRect{
        didSet{
            setupLayerFrames()
        }
    }
    
    override var bounds: CGRect{
        didSet{
            setupLayerFrames()
        }
    }
    
    func setupProperties(){
        
    }
    
    func setupLayers(){
        let cloud = CAShapeLayer()
        self.layer.addSublayer(cloud)
        cloud.anchorPoint   = CGPoint(x: 0.6, y: 0.5)
        cloud.frame         = CGRect(x: 0.11126 * cloud.superlayer!.bounds.width, y: 0.22447 * cloud.superlayer!.bounds.height, width: 0.64 * cloud.superlayer!.bounds.width, height: 0.44592 * cloud.superlayer!.bounds.height)
        cloud.fillColor     = nil
        cloud.strokeColor   = UIColor.black.cgColor
        cloud.lineWidth     = 3
        cloud.strokeEnd     = 0
        cloud.lineDashPhase = 1.5
        layers["cloud"] = cloud
        
        let cloud2 = CAShapeLayer()
        self.layer.addSublayer(cloud2)
        cloud2.anchorPoint   = CGPoint(x: 0.6, y: 0.5)
        cloud2.frame         = CGRect(x: 0.10927 * cloud2.superlayer!.bounds.width, y: 0.22247 * cloud2.superlayer!.bounds.height, width: 0.64 * cloud2.superlayer!.bounds.width, height: 0.44592 * cloud2.superlayer!.bounds.height)
        cloud2.fillColor     = nil
        cloud2.strokeColor   = UIColor.black.cgColor
        cloud2.lineWidth     = 3
        cloud2.strokeStart   = 1
        cloud2.shadowColor   = UIColor(red:0, green: 0, blue:0, alpha:0.333).cgColor
        cloud2.shadowOpacity = 0.33
        cloud2.shadowOffset  = CGSize(width: 4, height: 4)
        cloud2.shadowRadius  = 5
        layers["cloud2"] = cloud2
        
        let cloud3 = CAShapeLayer()
        self.layer.addSublayer(cloud3)
        cloud3.fillColor   = UIColor.white.cgColor
        cloud3.strokeColor = UIColor.black.cgColor
        cloud3.lineWidth   = 3
        cloud3.strokeStart = 1
        layers["cloud3"] = cloud3
        
        let cloud4 = CAShapeLayer()
        self.layer.addSublayer(cloud4)
        cloud4.lineJoin    = kCALineJoinRound
        cloud4.fillColor   = nil
        cloud4.strokeColor = UIColor.black.cgColor
        cloud4.lineWidth   = 3
        cloud4.strokeEnd   = 0
        layers["cloud4"] = cloud4
        setupLayerFrames()
    }
    
    func setupLayerFrames(){
        CATransaction.begin()
        CATransaction.setDisableActions(true)
        
        if let cloud : CAShapeLayer = layers["cloud"] as? CAShapeLayer{
            cloud.frame = CGRect(x: 0.11126 * cloud.superlayer!.bounds.width, y: 0.22447 * cloud.superlayer!.bounds.height, width: 0.64 * cloud.superlayer!.bounds.width, height: 0.44592 * cloud.superlayer!.bounds.height)
            cloud.path  = cloudPath(bounds: (layers["cloud"] as! CAShapeLayer).bounds).cgPath
        }
        
        if let cloud2 : CAShapeLayer = layers["cloud2"] as? CAShapeLayer{
            cloud2.frame = CGRect(x: 0.10927 * cloud2.superlayer!.bounds.width, y: 0.22247 * cloud2.superlayer!.bounds.height, width: 0.64 * cloud2.superlayer!.bounds.width, height: 0.44592 * cloud2.superlayer!.bounds.height)
            cloud2.path  = cloud2Path(bounds: (layers["cloud2"] as! CAShapeLayer).bounds).cgPath
        }
        
        if let cloud3 : CAShapeLayer = layers["cloud3"] as? CAShapeLayer{
            cloud3.frame = CGRect(x: 0.25067 * cloud3.superlayer!.bounds.width, y: 0.33161 * cloud3.superlayer!.bounds.height, width: 0.64 * cloud3.superlayer!.bounds.width, height: 0.44592 * cloud3.superlayer!.bounds.height)
            cloud3.path  = cloud3Path(bounds: (layers["cloud3"] as! CAShapeLayer).bounds).cgPath
        }
        
        if let cloud4 : CAShapeLayer = layers["cloud4"] as? CAShapeLayer{
            cloud4.frame = CGRect(x: 0.25073 * cloud4.superlayer!.bounds.width, y: 0.33148 * cloud4.superlayer!.bounds.height, width: 0.64 * cloud4.superlayer!.bounds.width, height: 0.44592 * cloud4.superlayer!.bounds.height)
            cloud4.path  = cloud4Path(bounds: (layers["cloud4"] as! CAShapeLayer).bounds).cgPath
        }
        
        CATransaction.commit()
    }
    
    //MARK: - Animation Setup
    
    func addOldAnimation(reverseAnimation: Bool = false, totalDuration: CFTimeInterval = 4.416, endTime: CFTimeInterval = 1, completionBlock: ((_ finished: Bool) -> Void)? = nil){
        let endTime = endTime * totalDuration
        
        if completionBlock != nil{
            let completionAnim = CABasicAnimation(keyPath:"completionAnim")
            completionAnim.duration = endTime
            completionAnim.delegate = self
            completionAnim.setValue("old", forKey:"animId")
            completionAnim.setValue(true, forKey:"needEndAnim")
            layer.add(completionAnim, forKey:"old")
            if let anim = layer.animation(forKey: "old"){
                completionBlocks[anim] = completionBlock
            }
        }
        
        self.layer.speed = 1
        self.animationAdded = false
        
        let fillMode : String = reverseAnimation ? kCAFillModeBoth : kCAFillModeForwards
        
        ////Cloud animation
        let cloudStrokeEndAnim            = CABasicAnimation(keyPath:"strokeEnd")
        cloudStrokeEndAnim.fromValue      = 0;
        cloudStrokeEndAnim.toValue        = 1;
        cloudStrokeEndAnim.duration       = 0.453 * totalDuration
        cloudStrokeEndAnim.beginTime      = 0.38 * totalDuration
        cloudStrokeEndAnim.timingFunction = CAMediaTimingFunction(name:kCAMediaTimingFunctionDefault)
        
        var cloudOldAnim : CAAnimationGroup = QCMethod.group(animations: [cloudStrokeEndAnim], fillMode:fillMode)
        if (reverseAnimation){ cloudOldAnim = QCMethod.reverseAnimation(anim: cloudOldAnim, totalDuration:totalDuration) as! CAAnimationGroup}
        layers["cloud"]?.add(cloudOldAnim, forKey:"cloudOldAnim")
        
        ////Cloud2 animation
        let cloud2StrokeStartAnim            = CABasicAnimation(keyPath:"strokeStart")
        cloud2StrokeStartAnim.fromValue      = 0.7;
        cloud2StrokeStartAnim.toValue        = 0;
        cloud2StrokeStartAnim.duration       = 0.453 * totalDuration
        cloud2StrokeStartAnim.beginTime      = 0.354 * totalDuration
        cloud2StrokeStartAnim.timingFunction = CAMediaTimingFunction(name:kCAMediaTimingFunctionDefault)
        
        let cloud2FillColorAnim            = CABasicAnimation(keyPath:"fillColor")
        cloud2FillColorAnim.fromValue      = UIColor(red:0.153, green: 0.216, blue:0.933, alpha:0).cgColor;
        cloud2FillColorAnim.toValue        = UIColor(red:0.435, green: 0.796, blue:0.945, alpha:1).cgColor;
        cloud2FillColorAnim.duration       = 0.176 * totalDuration
        cloud2FillColorAnim.beginTime      = 0.574 * totalDuration
        cloud2FillColorAnim.timingFunction = CAMediaTimingFunction(name:kCAMediaTimingFunctionDefault)
        
        var cloud2OldAnim : CAAnimationGroup = QCMethod.group(animations: [cloud2StrokeStartAnim, cloud2FillColorAnim], fillMode:fillMode)
        if (reverseAnimation){ cloud2OldAnim = QCMethod.reverseAnimation(anim: cloud2OldAnim, totalDuration:totalDuration) as! CAAnimationGroup}
        layers["cloud2"]?.add(cloud2OldAnim, forKey:"cloud2OldAnim")
        
        ////Cloud3 animation
        let cloud3StrokeStartAnim            = CABasicAnimation(keyPath:"strokeStart")
        cloud3StrokeStartAnim.fromValue      = 1;
        cloud3StrokeStartAnim.toValue        = 0;
        cloud3StrokeStartAnim.duration       = 0.408 * totalDuration
        cloud3StrokeStartAnim.timingFunction = CAMediaTimingFunction(name:kCAMediaTimingFunctionEaseIn)
        
        var cloud3OldAnim : CAAnimationGroup = QCMethod.group(animations: [cloud3StrokeStartAnim], fillMode:fillMode)
        if (reverseAnimation){ cloud3OldAnim = QCMethod.reverseAnimation(anim: cloud3OldAnim, totalDuration:totalDuration) as! CAAnimationGroup}
        layers["cloud3"]?.add(cloud3OldAnim, forKey:"cloud3OldAnim")
        
        ////Cloud4 animation
        let cloud4StrokeEndAnim            = CABasicAnimation(keyPath:"strokeEnd")
        cloud4StrokeEndAnim.fromValue      = 0;
        cloud4StrokeEndAnim.toValue        = 1;
        cloud4StrokeEndAnim.duration       = 0.408 * totalDuration
        cloud4StrokeEndAnim.timingFunction = CAMediaTimingFunction(name:kCAMediaTimingFunctionEaseIn)
        
        let cloud4FillColorAnim            = CABasicAnimation(keyPath:"fillColor")
        cloud4FillColorAnim.fromValue      = UIColor(red:1, green: 1, blue:1, alpha:0).cgColor;
        cloud4FillColorAnim.toValue        = UIColor(red:0.459, green: 0.835, blue:0.992, alpha:1).cgColor;
        cloud4FillColorAnim.duration       = 0.453 * totalDuration
        cloud4FillColorAnim.beginTime      = 0.282 * totalDuration
        cloud4FillColorAnim.timingFunction = CAMediaTimingFunction(name:kCAMediaTimingFunctionDefault)
        
        let cloud4ShadowColorAnim              = CAKeyframeAnimation(keyPath:"shadowColor")
        cloud4ShadowColorAnim.values           = [UIColor.black.cgColor,
                                                  UIColor.black.cgColor,
                                                  UIColor(red:0.451, green: 0.451, blue:0.451, alpha:1).cgColor]
        cloud4ShadowColorAnim.duration         = 0.366 * totalDuration
        cloud4ShadowColorAnim.beginTime        = 0.634 * totalDuration
        cloud4ShadowColorAnim.timingFunction   = CAMediaTimingFunction(name:kCAMediaTimingFunctionEaseOut)
        let cloud4ShadowOpacityAnim            = CAKeyframeAnimation(keyPath:"shadowOpacity")
        cloud4ShadowOpacityAnim.values         = [0.216, 0.34, 0.601]
        cloud4ShadowOpacityAnim.duration       = 0.366 * totalDuration
        cloud4ShadowOpacityAnim.beginTime      = 0.634 * totalDuration
        cloud4ShadowOpacityAnim.timingFunction = CAMediaTimingFunction(name:kCAMediaTimingFunctionEaseOut)
        let cloud4ShadowOffsetAnim             = CAKeyframeAnimation(keyPath:"shadowOffset")
        cloud4ShadowOffsetAnim.values          = [NSValue(cgSize: CGSize(width: 0, height: 3)),
                                                  NSValue(cgSize: CGSize(width: 0, height: 10)),
                                                  NSValue(cgSize: CGSize(width: 8, height: 12))]
        cloud4ShadowOffsetAnim.duration        = 0.366 * totalDuration
        cloud4ShadowOffsetAnim.beginTime       = 0.634 * totalDuration
        cloud4ShadowOffsetAnim.timingFunction  = CAMediaTimingFunction(name:kCAMediaTimingFunctionEaseOut)
        
        var cloud4OldAnim : CAAnimationGroup = QCMethod.group(animations: [cloud4StrokeEndAnim, cloud4FillColorAnim, cloud4ShadowColorAnim, cloud4ShadowOpacityAnim, cloud4ShadowOffsetAnim], fillMode:fillMode)
        if (reverseAnimation){ cloud4OldAnim = QCMethod.reverseAnimation(anim: cloud4OldAnim, totalDuration:totalDuration) as! CAAnimationGroup}
        layers["cloud4"]?.add(cloud4OldAnim, forKey:"cloud4OldAnim")
    }
    
    //MARK: - Animation Cleanup
    
    func animationDidStop(_ anim: CAAnimation, finished flag: Bool){
        if let completionBlock = completionBlocks[anim]{
            completionBlocks.removeValue(forKey: anim)
            if (flag && updateLayerValueForCompletedAnimation) || anim.value(forKey: "needEndAnim") as! Bool{
                updateLayerValues(forAnimationId: anim.value(forKey: "animId") as! String)
                removeAnimations(forAnimationId: anim.value(forKey: "animId") as! String)
            }
            completionBlock(flag)
        }
    }
    
    func updateLayerValues(forAnimationId identifier: String){
        if identifier == "old"{
            QCMethod.updateValueFromPresentationLayer(forAnimation: (layers["cloud"] as! CALayer).animation(forKey: "cloudOldAnim"), theLayer:(layers["cloud"] as! CALayer))
            QCMethod.updateValueFromPresentationLayer(forAnimation: (layers["cloud2"] as! CALayer).animation(forKey: "cloud2OldAnim"), theLayer:(layers["cloud2"] as! CALayer))
            QCMethod.updateValueFromPresentationLayer(forAnimation: (layers["cloud3"] as! CALayer).animation(forKey: "cloud3OldAnim"), theLayer:(layers["cloud3"] as! CALayer))
            QCMethod.updateValueFromPresentationLayer(forAnimation: (layers["cloud4"] as! CALayer).animation(forKey: "cloud4OldAnim"), theLayer:(layers["cloud4"] as! CALayer))
        }
    }
    
    func removeAnimations(forAnimationId identifier: String){
        if identifier == "old"{
            (layers["cloud"] as! CALayer).removeAnimation(forKey: "cloudOldAnim")
            (layers["cloud2"] as! CALayer).removeAnimation(forKey: "cloud2OldAnim")
            (layers["cloud3"] as! CALayer).removeAnimation(forKey: "cloud3OldAnim")
            (layers["cloud4"] as! CALayer).removeAnimation(forKey: "cloud4OldAnim")
        }
        self.layer.speed = 1
    }
    
    func removeAllAnimations(){
        for layer in layers.values{
            (layer as! CALayer).removeAllAnimations()
        }
        self.layer.speed = 1
    }
    
    //MARK: - Bezier Path
    
    func cloudPath(bounds: CGRect) -> UIBezierPath{
        let cloudPath = UIBezierPath()
        let minX = CGFloat(bounds.minX), minY = bounds.minY, w = bounds.width, h = bounds.height;
        
        cloudPath.move(to: CGPoint(x:minX + 0.874 * w, y: minY + 0.4503 * h))
        cloudPath.addLine(to: CGPoint(x:minX + 0.874 * w, y: minY + 0.43595 * h))
        cloudPath.addCurve(to: CGPoint(x:minX + 0.874 * w, y: minY + 0.3685 * h), controlPoint1:CGPoint(x:minX + 0.874 * w, y: minY + 0.43595 * h), controlPoint2:CGPoint(x:minX + 0.874 * w, y: minY + 0.43308 * h))
        cloudPath.addCurve(to: CGPoint(x:minX + 0.634 * w, y: minY + 0.00538 * h), controlPoint1:CGPoint(x:minX + 0.874 * w, y: minY + 0.30391 * h), controlPoint2:CGPoint(x:minX + 0.85 * w, y: minY + 0.04844 * h))
        cloudPath.addCurve(to: CGPoint(x:minX + 0.347 * w, y: minY + 0.20631 * h), controlPoint1:CGPoint(x:minX + 0.444 * w, y: minY + -0.03194 * h), controlPoint2:CGPoint(x:minX + 0.362 * w, y: minY + 0.13455 * h))
        cloudPath.addCurve(to: CGPoint(x:minX + 0.122 * w, y: minY + 0.49049 * h), controlPoint1:CGPoint(x:minX + 0.347 * w, y: minY + 0.20631 * h), controlPoint2:CGPoint(x:minX + 0.11 * w, y: minY + 0.14603 * h))
        cloudPath.addCurve(to: CGPoint(x:minX, y: minY + 0.73735 * h), controlPoint1:CGPoint(x:minX + 0.122 * w, y: minY + 0.49049 * h), controlPoint2:CGPoint(x:minX, y: minY + 0.5766 * h))
        cloudPath.addCurve(to: CGPoint(x:minX + 0.173 * w, y: minY + h), controlPoint1:CGPoint(x:minX, y: minY + 0.89953 * h), controlPoint2:CGPoint(x:minX + 0.077 * w, y: minY + h))
        cloudPath.addCurve(to: CGPoint(x:minX + 0.85 * w, y: minY + h), controlPoint1:CGPoint(x:minX + 0.269 * w, y: minY + h), controlPoint2:CGPoint(x:minX + 0.805 * w, y: minY + h))
        cloudPath.addCurve(to: CGPoint(x:minX + w, y: minY + 0.74166 * h), controlPoint1:CGPoint(x:minX + 0.895 * w, y: minY + h), controlPoint2:CGPoint(x:minX + w, y: minY + 0.89953 * h))
        cloudPath.addCurve(to: CGPoint(x:minX + 0.874 * w, y: minY + 0.4503 * h), controlPoint1:CGPoint(x:minX + w, y: minY + 0.58378 * h), controlPoint2:CGPoint(x:minX + 0.929 * w, y: minY + 0.49336 * h))
        cloudPath.close()
        cloudPath.move(to: CGPoint(x:minX + 0.874 * w, y: minY + 0.4503 * h))
        
        return cloudPath
    }
    
    func cloud2Path(bounds: CGRect) -> UIBezierPath{
        let cloud2Path = UIBezierPath()
        let minX = CGFloat(bounds.minX), minY = bounds.minY, w = bounds.width, h = bounds.height;
        
        cloud2Path.move(to: CGPoint(x:minX + 0.874 * w, y: minY + 0.4503 * h))
        cloud2Path.addLine(to: CGPoint(x:minX + 0.874 * w, y: minY + 0.43595 * h))
        cloud2Path.addCurve(to: CGPoint(x:minX + 0.874 * w, y: minY + 0.3685 * h), controlPoint1:CGPoint(x:minX + 0.874 * w, y: minY + 0.43595 * h), controlPoint2:CGPoint(x:minX + 0.874 * w, y: minY + 0.43308 * h))
        cloud2Path.addCurve(to: CGPoint(x:minX + 0.634 * w, y: minY + 0.00538 * h), controlPoint1:CGPoint(x:minX + 0.874 * w, y: minY + 0.30391 * h), controlPoint2:CGPoint(x:minX + 0.85 * w, y: minY + 0.04844 * h))
        cloud2Path.addCurve(to: CGPoint(x:minX + 0.347 * w, y: minY + 0.20631 * h), controlPoint1:CGPoint(x:minX + 0.444 * w, y: minY + -0.03194 * h), controlPoint2:CGPoint(x:minX + 0.362 * w, y: minY + 0.13455 * h))
        cloud2Path.addCurve(to: CGPoint(x:minX + 0.122 * w, y: minY + 0.49049 * h), controlPoint1:CGPoint(x:minX + 0.347 * w, y: minY + 0.20631 * h), controlPoint2:CGPoint(x:minX + 0.11 * w, y: minY + 0.14603 * h))
        cloud2Path.addCurve(to: CGPoint(x:minX, y: minY + 0.73735 * h), controlPoint1:CGPoint(x:minX + 0.122 * w, y: minY + 0.49049 * h), controlPoint2:CGPoint(x:minX, y: minY + 0.5766 * h))
        cloud2Path.addCurve(to: CGPoint(x:minX + 0.173 * w, y: minY + h), controlPoint1:CGPoint(x:minX, y: minY + 0.89953 * h), controlPoint2:CGPoint(x:minX + 0.077 * w, y: minY + h))
        cloud2Path.addCurve(to: CGPoint(x:minX + 0.85 * w, y: minY + h), controlPoint1:CGPoint(x:minX + 0.269 * w, y: minY + h), controlPoint2:CGPoint(x:minX + 0.805 * w, y: minY + h))
        cloud2Path.addCurve(to: CGPoint(x:minX + w, y: minY + 0.74166 * h), controlPoint1:CGPoint(x:minX + 0.895 * w, y: minY + h), controlPoint2:CGPoint(x:minX + w, y: minY + 0.89953 * h))
        cloud2Path.addCurve(to: CGPoint(x:minX + 0.874 * w, y: minY + 0.4503 * h), controlPoint1:CGPoint(x:minX + w, y: minY + 0.58378 * h), controlPoint2:CGPoint(x:minX + 0.929 * w, y: minY + 0.49336 * h))
        cloud2Path.close()
        cloud2Path.move(to: CGPoint(x:minX + 0.874 * w, y: minY + 0.4503 * h))
        
        return cloud2Path
    }
    
    func cloud3Path(bounds: CGRect) -> UIBezierPath{
        let cloud3Path = UIBezierPath()
        let minX = CGFloat(bounds.minX), minY = bounds.minY, w = bounds.width, h = bounds.height;
        
        cloud3Path.move(to: CGPoint(x:minX + 0.126 * w, y: minY + 0.4503 * h))
        cloud3Path.addLine(to: CGPoint(x:minX + 0.126 * w, y: minY + 0.43595 * h))
        cloud3Path.addCurve(to: CGPoint(x:minX + 0.126 * w, y: minY + 0.3685 * h), controlPoint1:CGPoint(x:minX + 0.126 * w, y: minY + 0.43595 * h), controlPoint2:CGPoint(x:minX + 0.126 * w, y: minY + 0.43308 * h))
        cloud3Path.addCurve(to: CGPoint(x:minX + 0.366 * w, y: minY + 0.00538 * h), controlPoint1:CGPoint(x:minX + 0.126 * w, y: minY + 0.30391 * h), controlPoint2:CGPoint(x:minX + 0.15 * w, y: minY + 0.04844 * h))
        cloud3Path.addCurve(to: CGPoint(x:minX + 0.653 * w, y: minY + 0.20631 * h), controlPoint1:CGPoint(x:minX + 0.556 * w, y: minY + -0.03194 * h), controlPoint2:CGPoint(x:minX + 0.638 * w, y: minY + 0.13455 * h))
        cloud3Path.addCurve(to: CGPoint(x:minX + 0.878 * w, y: minY + 0.49049 * h), controlPoint1:CGPoint(x:minX + 0.653 * w, y: minY + 0.20631 * h), controlPoint2:CGPoint(x:minX + 0.89 * w, y: minY + 0.14603 * h))
        cloud3Path.addCurve(to: CGPoint(x:minX + w, y: minY + 0.73735 * h), controlPoint1:CGPoint(x:minX + 0.878 * w, y: minY + 0.49049 * h), controlPoint2:CGPoint(x:minX + w, y: minY + 0.5766 * h))
        cloud3Path.addCurve(to: CGPoint(x:minX + 0.827 * w, y: minY + h), controlPoint1:CGPoint(x:minX + w, y: minY + 0.89953 * h), controlPoint2:CGPoint(x:minX + 0.923 * w, y: minY + h))
        cloud3Path.addCurve(to: CGPoint(x:minX + 0.15 * w, y: minY + h), controlPoint1:CGPoint(x:minX + 0.731 * w, y: minY + h), controlPoint2:CGPoint(x:minX + 0.195 * w, y: minY + h))
        cloud3Path.addCurve(to: CGPoint(x:minX, y: minY + 0.74166 * h), controlPoint1:CGPoint(x:minX + 0.105 * w, y: minY + h), controlPoint2:CGPoint(x:minX, y: minY + 0.89953 * h))
        cloud3Path.addCurve(to: CGPoint(x:minX + 0.126 * w, y: minY + 0.4503 * h), controlPoint1:CGPoint(x:minX, y: minY + 0.58378 * h), controlPoint2:CGPoint(x:minX + 0.071 * w, y: minY + 0.49336 * h))
        cloud3Path.close()
        cloud3Path.move(to: CGPoint(x:minX + 0.126 * w, y: minY + 0.4503 * h))
        
        return cloud3Path
    }
    
    func cloud4Path(bounds: CGRect) -> UIBezierPath{
        let cloud4Path = UIBezierPath()
        let minX = CGFloat(bounds.minX), minY = bounds.minY, w = bounds.width, h = bounds.height;
        
        cloud4Path.move(to: CGPoint(x:minX + 0.126 * w, y: minY + 0.4503 * h))
        cloud4Path.addLine(to: CGPoint(x:minX + 0.126 * w, y: minY + 0.43595 * h))
        cloud4Path.addCurve(to: CGPoint(x:minX + 0.126 * w, y: minY + 0.3685 * h), controlPoint1:CGPoint(x:minX + 0.126 * w, y: minY + 0.43595 * h), controlPoint2:CGPoint(x:minX + 0.126 * w, y: minY + 0.43308 * h))
        cloud4Path.addCurve(to: CGPoint(x:minX + 0.366 * w, y: minY + 0.00538 * h), controlPoint1:CGPoint(x:minX + 0.126 * w, y: minY + 0.30391 * h), controlPoint2:CGPoint(x:minX + 0.15 * w, y: minY + 0.04844 * h))
        cloud4Path.addCurve(to: CGPoint(x:minX + 0.653 * w, y: minY + 0.20631 * h), controlPoint1:CGPoint(x:minX + 0.556 * w, y: minY + -0.03194 * h), controlPoint2:CGPoint(x:minX + 0.638 * w, y: minY + 0.13455 * h))
        cloud4Path.addCurve(to: CGPoint(x:minX + 0.878 * w, y: minY + 0.49049 * h), controlPoint1:CGPoint(x:minX + 0.653 * w, y: minY + 0.20631 * h), controlPoint2:CGPoint(x:minX + 0.89 * w, y: minY + 0.14603 * h))
        cloud4Path.addCurve(to: CGPoint(x:minX + w, y: minY + 0.73735 * h), controlPoint1:CGPoint(x:minX + 0.878 * w, y: minY + 0.49049 * h), controlPoint2:CGPoint(x:minX + w, y: minY + 0.5766 * h))
        cloud4Path.addCurve(to: CGPoint(x:minX + 0.827 * w, y: minY + h), controlPoint1:CGPoint(x:minX + w, y: minY + 0.89953 * h), controlPoint2:CGPoint(x:minX + 0.923 * w, y: minY + h))
        cloud4Path.addCurve(to: CGPoint(x:minX + 0.15 * w, y: minY + h), controlPoint1:CGPoint(x:minX + 0.731 * w, y: minY + h), controlPoint2:CGPoint(x:minX + 0.195 * w, y: minY + h))
        cloud4Path.addCurve(to: CGPoint(x:minX, y: minY + 0.74166 * h), controlPoint1:CGPoint(x:minX + 0.105 * w, y: minY + h), controlPoint2:CGPoint(x:minX, y: minY + 0.89953 * h))
        cloud4Path.addCurve(to: CGPoint(x:minX + 0.126 * w, y: minY + 0.4503 * h), controlPoint1:CGPoint(x:minX, y: minY + 0.58378 * h), controlPoint2:CGPoint(x:minX + 0.071 * w, y: minY + 0.49336 * h))
        cloud4Path.close()
        cloud4Path.move(to: CGPoint(x:minX + 0.126 * w, y: minY + 0.4503 * h))
        
        return cloud4Path
    }
    
    
}
