//
//  FillView.m
//
//  Code generated using QuartzCode 1.35.2 on 7/22/15.
//  www.quartzcodeapp.com
//

#import "FillView.h"
#import "QCMethod.h"

@interface FillView ()

@property (nonatomic, assign) BOOL  updateLayerValueForCompletedAnimation;
@property (nonatomic, assign) BOOL  animationAdded;
@property (nonatomic, strong) NSMapTable * completionBlocks;
@property (nonatomic, strong) NSMutableDictionary * layers;


@end

@implementation FillView

#pragma mark - Life Cycle

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        [self setupProperties];
        [self setupLayers];
    }
    return self;
}

- (instancetype)initWithCoder:(NSCoder *)coder
{
    self = [super initWithCoder:coder];
    if (self) {
        [self setupProperties];
        [self setupLayers];
    }
    return self;
}

- (void)setFillAnimProgress:(CGFloat)fillAnimProgress{
    if(!self.animationAdded){
        [self removeAllAnimations];
        [self addFillAnimation];
        self.animationAdded = YES;
        self.layer.speed = 0;
        self.layer.timeOffset = 0;
    }
    else{
        CGFloat totalDuration = 2.41;
        CGFloat offset = fillAnimProgress * totalDuration;
        self.layer.timeOffset = offset;
    }
}

- (void)setFrame:(CGRect)frame{
    [super setFrame:frame];
    [self setupLayerFrames];
}

- (void)setBounds:(CGRect)bounds{
    [super setBounds:bounds];
    [self setupLayerFrames];
}

- (void)setupProperties{
    self.completionBlocks = [NSMapTable mapTableWithKeyOptions:NSPointerFunctionsOpaqueMemory valueOptions:NSPointerFunctionsStrongMemory];;
    self.layers = [NSMutableDictionary dictionary];
    
}

- (void)setupLayers{
    CALayer * water = [CALayer layer];
    [self.layer addSublayer:water];
    water.anchorPoint     = CGPointMake(0.5, 1);
    water.backgroundColor = [UIColor colorWithRed:0.376 green: 0.784 blue:0.906 alpha:1].CGColor;
    self.layers[@"water"] = water;
    CAShapeLayer * path = [CAShapeLayer layer];
    [water addSublayer:path];
    path.fillColor = [UIColor colorWithRed:0.376 green: 0.784 blue:0.906 alpha:1].CGColor;
    path.lineWidth = 0;
    self.layers[@"path"] = path;
    CAShapeLayer * path2 = [CAShapeLayer layer];
    [water addSublayer:path2];
    path2.hidden    = YES;
    path2.fillColor = [UIColor colorWithRed:0.243 green: 0.584 blue:0.725 alpha:1].CGColor;
    path2.lineWidth = 0;
    self.layers[@"path2"] = path2;
    CAShapeLayer * path3 = [CAShapeLayer layer];
    [water addSublayer:path3];
    path3.hidden    = YES;
    path3.fillColor = [UIColor colorWithRed:0.243 green: 0.584 blue:0.725 alpha:1].CGColor;
    path3.lineWidth = 0;
    self.layers[@"path3"] = path3;
    
    CAShapeLayer * rectangle = [CAShapeLayer layer];
    [self.layer addSublayer:rectangle];
    rectangle.fillColor   = nil;
    rectangle.strokeColor = [UIColor colorWithRed:0.329 green: 0.329 blue:0.329 alpha:1].CGColor;
    rectangle.lineWidth   = 2;
    self.layers[@"rectangle"] = rectangle;
    
    [self setupLayerFrames];
}

- (void)setupLayerFrames{
    [CATransaction begin];
    [CATransaction setDisableActions:YES];
    
    CALayer * water          = self.layers[@"water"];
    water.frame              = CGRectMake(0.198 * CGRectGetWidth(water.superlayer.bounds), 0.858 * CGRectGetHeight(water.superlayer.bounds), 0.6017 * CGRectGetWidth(water.superlayer.bounds), 0.004 * CGRectGetHeight(water.superlayer.bounds));
    
    CAShapeLayer * path      = self.layers[@"path"];
    path.frame               = CGRectMake(0.00105 * CGRectGetWidth(path.superlayer.bounds), -37.60629 * CGRectGetHeight(path.superlayer.bounds), 1.00172 * CGRectGetWidth(path.superlayer.bounds), 38.21089 * CGRectGetHeight(path.superlayer.bounds));
    path.path                = [self pathPathWithBounds:[self.layers[@"path"] bounds]].CGPath;
    
    CAShapeLayer * path2     = self.layers[@"path2"];
    path2.frame              = CGRectMake(-0.64501 * CGRectGetWidth(path2.superlayer.bounds), 33.8544 * CGRectGetHeight(path2.superlayer.bounds), 1.00172 * CGRectGetWidth(path2.superlayer.bounds), 35.57003 * CGRectGetHeight(path2.superlayer.bounds));
    path2.path               = [self path2PathWithBounds:[self.layers[@"path2"] bounds]].CGPath;
    
    CAShapeLayer * path3     = self.layers[@"path3"];
    path3.frame              = CGRectMake(-0.53882 * CGRectGetWidth(path3.superlayer.bounds), 6.69454 * CGRectGetHeight(path3.superlayer.bounds), 1.00172 * CGRectGetWidth(path3.superlayer.bounds), 41.61322 * CGRectGetHeight(path3.superlayer.bounds));
    path3.path               = [self path3PathWithBounds:[self.layers[@"path3"] bounds]].CGPath;
    
    CAShapeLayer * rectangle = self.layers[@"rectangle"];
    rectangle.frame          = CGRectMake(0.2 * CGRectGetWidth(rectangle.superlayer.bounds), 0.14 * CGRectGetHeight(rectangle.superlayer.bounds), 0.6 * CGRectGetWidth(rectangle.superlayer.bounds), 0.72 * CGRectGetHeight(rectangle.superlayer.bounds));
    rectangle.path           = [self rectanglePathWithBounds:[self.layers[@"rectangle"] bounds]].CGPath;
    
    [CATransaction commit];
}

#pragma mark - Animation Setup

- (void)addFillAnimation{
    [self addFillAnimationCompletionBlock:nil];
}

- (void)addFillAnimationCompletionBlock:(void (^)(BOOL finished))completionBlock{
    [self addFillAnimationReverse:NO totalDuration:2.63 endTime:1 completionBlock:completionBlock];
}

- (void)addFillAnimationReverse:(BOOL)reverseAnimation totalDuration:(CFTimeInterval)totalDuration endTime:(CFTimeInterval)endTime completionBlock:(void (^)(BOOL finished))completionBlock{
    endTime = endTime * totalDuration;
    
    if (completionBlock){
        CABasicAnimation * completionAnim = [CABasicAnimation animationWithKeyPath:@"completionAnim"];;
        completionAnim.duration = endTime;
        completionAnim.delegate = self;
        [completionAnim setValue:@"fill" forKey:@"animId"];
        [completionAnim setValue:@(YES) forKey:@"needEndAnim"];
        [self.layer addAnimation:completionAnim forKey:@"fill"];
        [self.completionBlocks setObject:completionBlock forKey:[self.layer animationForKey:@"fill"]];
    }
    
    NSString * fillMode = reverseAnimation ? kCAFillModeBoth : kCAFillModeForwards;
    
    CALayer * water = self.layers[@"water"];
    
    ////Water animation
    CABasicAnimation * waterBoundsAnim = [CABasicAnimation animationWithKeyPath:@"bounds"];
    waterBoundsAnim.fromValue          = [NSValue valueWithCGRect:CGRectMake(0, 0, 0.6017 * CGRectGetWidth(water.superlayer.bounds), 0.004 * CGRectGetHeight(water.superlayer.bounds))];
    waterBoundsAnim.toValue            = [NSValue valueWithCGRect:CGRectMake(0, 0, 0.60162 * CGRectGetWidth(water.superlayer.bounds), 0.64 * CGRectGetHeight(water.superlayer.bounds))];
    waterBoundsAnim.duration           = 0.782 * totalDuration;
    
    CAAnimationGroup * waterFillAnim = [QCMethod groupAnimations:@[waterBoundsAnim] fillMode:fillMode];
    if (reverseAnimation) waterFillAnim = (CAAnimationGroup *)[QCMethod reverseAnimation:waterFillAnim totalDuration:totalDuration];
    [self.layers[@"water"] addAnimation:waterFillAnim forKey:@"waterFillAnim"];
    
    ////Path animation
    CAKeyframeAnimation * pathPathAnim = [CAKeyframeAnimation animationWithKeyPath:@"path"];
    pathPathAnim.values                = @[(id)[QCMethod alignToBottomPath:[self pathPathWithBounds:[self.layers[@"path"] bounds]] layer:self.layers[@"path"]].CGPath, (id)[QCMethod alignToBottomPath:[self path2PathWithBounds:[self.layers[@"path2"] bounds]] layer:self.layers[@"path"]].CGPath, (id)[QCMethod alignToBottomPath:[self path3PathWithBounds:[self.layers[@"path3"] bounds]] layer:self.layers[@"path"]].CGPath];
    pathPathAnim.keyTimes              = @[@0, @0.486, @1];
    pathPathAnim.duration              = 0.167 * totalDuration;
    pathPathAnim.repeatCount           = 3;
    pathPathAnim.autoreverses          = YES;
    
    CAShapeLayer * path = self.layers[@"path"];
    
    CAKeyframeAnimation * pathTransformAnim = [CAKeyframeAnimation animationWithKeyPath:@"transform"];
    pathTransformAnim.values       = @[[NSValue valueWithCATransform3D:CATransform3DIdentity],
                                       [NSValue valueWithCATransform3D:CATransform3DConcat(CATransform3DMakeTranslation(0.013296 * CGRectGetWidth(path.superlayer.bounds), 12.001 * CGRectGetHeight(path.superlayer.bounds), 0), CATransform3DMakeRotation(9 * M_PI/180, 0, -0, 1))],
                                       [NSValue valueWithCATransform3D:CATransform3DConcat(CATransform3DMakeTranslation(-0.019944 * CGRectGetWidth(path.superlayer.bounds), 14.001 * CGRectGetHeight(path.superlayer.bounds), 0), CATransform3DMakeRotation(-7 * M_PI/180, -0, 0, 1))]];
    pathTransformAnim.keyTimes     = @[@0, @0.478, @1];
    pathTransformAnim.duration     = 0.299 * totalDuration;
    pathTransformAnim.beginTime    = 0.164 * totalDuration;
    pathTransformAnim.autoreverses = YES;
    
    CABasicAnimation * pathPositionAnim = [CABasicAnimation animationWithKeyPath:@"position"];
    pathPositionAnim.fromValue          = [NSValue valueWithCGPoint:CGPointMake(0.50191 * CGRectGetWidth(path.superlayer.bounds), -18.50085 * CGRectGetHeight(path.superlayer.bounds))];
    pathPositionAnim.toValue            = [NSValue valueWithCGPoint:CGPointMake(0.49527 * CGRectGetWidth(path.superlayer.bounds), 18.50076 * CGRectGetHeight(path.superlayer.bounds))];
    pathPositionAnim.duration           = 0.453 * totalDuration;
    pathPositionAnim.beginTime          = 0.463 * totalDuration;
    
    CAAnimationGroup * pathFillAnim = [QCMethod groupAnimations:@[pathPathAnim, pathTransformAnim, pathPositionAnim] fillMode:fillMode];
    if (reverseAnimation) pathFillAnim = (CAAnimationGroup *)[QCMethod reverseAnimation:pathFillAnim totalDuration:totalDuration];
    [self.layers[@"path"] addAnimation:pathFillAnim forKey:@"pathFillAnim"];
}

#pragma mark - Animation Cleanup

- (void)animationDidStop:(CAAnimation *)anim finished:(BOOL)flag{
    void (^completionBlock)(BOOL) = [self.completionBlocks objectForKey:anim];;
    if (completionBlock){
        [self.completionBlocks removeObjectForKey:anim];
        if ((flag && self.updateLayerValueForCompletedAnimation) || [[anim valueForKey:@"needEndAnim"] boolValue]){
            [self updateLayerValuesForAnimationId:[anim valueForKey:@"animId"]];
            [self removeAnimationsForAnimationId:[anim valueForKey:@"animId"]];
        }
        completionBlock(flag);
    }
}

- (void)updateLayerValuesForAnimationId:(NSString *)identifier{
    if([identifier isEqualToString:@"fill"]){
        [QCMethod updateValueFromPresentationLayerForAnimation:[self.layers[@"water"] animationForKey:@"waterFillAnim"] theLayer:self.layers[@"water"]];
        [QCMethod updateValueFromPresentationLayerForAnimation:[self.layers[@"path"] animationForKey:@"pathFillAnim"] theLayer:self.layers[@"path"]];
    }
}

- (void)removeAnimationsForAnimationId:(NSString *)identifier{
    if([identifier isEqualToString:@"fill"]){
        [self.layers[@"water"] removeAnimationForKey:@"waterFillAnim"];
        [self.layers[@"path"] removeAnimationForKey:@"pathFillAnim"];
    }
    self.layer.speed = 1;
}

- (void)removeAllAnimations{
    [self.layers enumerateKeysAndObjectsUsingBlock:^(id key, CALayer *layer, BOOL *stop) {
        [layer removeAllAnimations];
    }];
    self.layer.speed = 1;
}

#pragma mark - Bezier Path

- (UIBezierPath*)pathPathWithBounds:(CGRect)bound{
    UIBezierPath *pathPath = [UIBezierPath bezierPath];
    CGFloat minX = CGRectGetMinX(bound), minY = CGRectGetMinY(bound), w = CGRectGetWidth(bound), h = CGRectGetHeight(bound);
    
    [pathPath moveToPoint:CGPointMake(minX + 0.0088 * w, minY + 0.98478 * h)];
    [pathPath addCurveToPoint:CGPointMake(minX + 0.02149 * w, minY + 0.13955 * h) controlPoint1:CGPointMake(minX + -0.00618 * w, minY + 0.64625 * h) controlPoint2:CGPointMake(minX + -0.00209 * w, minY + 0.17543 * h)];
    [pathPath addCurveToPoint:CGPointMake(minX + 0.25274 * w, minY + 0.13955 * h) controlPoint1:CGPointMake(minX + 0.04508 * w, minY + 0.10368 * h) controlPoint2:CGPointMake(minX + 0.1076 * w, minY + -0.15567 * h)];
    [pathPath addCurveToPoint:CGPointMake(minX + 0.48643 * w, minY + 0.10366 * h) controlPoint1:CGPointMake(minX + 0.41331 * w, minY + 0.46618 * h) controlPoint2:CGPointMake(minX + 0.23845 * w, minY + 0.34101 * h)];
    [pathPath addCurveToPoint:CGPointMake(minX + 0.75336 * w, minY + 0.13181 * h) controlPoint1:CGPointMake(minX + 0.73441 * w, minY + -0.13369 * h) controlPoint2:CGPointMake(minX + 0.6791 * w, minY + 0.44726 * h)];
    [pathPath addCurveToPoint:CGPointMake(minX + 0.94687 * w, minY + 0.46377 * h) controlPoint1:CGPointMake(minX + 0.79072 * w, minY + -0.02692 * h) controlPoint2:CGPointMake(minX + 0.88135 * w, minY + 0.00552 * h)];
    [pathPath addCurveToPoint:CGPointMake(minX + w, minY + h) controlPoint1:CGPointMake(minX + 0.99832 * w, minY + 0.82364 * h) controlPoint2:CGPointMake(minX + 0.99473 * w, minY + -0.08546 * h)];
    
    return pathPath;
}

- (UIBezierPath*)path2PathWithBounds:(CGRect)bound{
    UIBezierPath *path2Path = [UIBezierPath bezierPath];
    CGFloat minX = CGRectGetMinX(bound), minY = CGRectGetMinY(bound), w = CGRectGetWidth(bound), h = CGRectGetHeight(bound);
    
    [path2Path moveToPoint:CGPointMake(minX + 0.0088 * w, minY + 0.98365 * h)];
    [path2Path addCurveToPoint:CGPointMake(minX + 0.02149 * w, minY + 0.07567 * h) controlPoint1:CGPointMake(minX + -0.00618 * w, minY + 0.61998 * h) controlPoint2:CGPointMake(minX + -0.00209 * w, minY + 0.11421 * h)];
    [path2Path addCurveToPoint:CGPointMake(minX + 0.25274 * w, minY + 0.07567 * h) controlPoint1:CGPointMake(minX + 0.04508 * w, minY + 0.03713 * h) controlPoint2:CGPointMake(minX + 0.11007 * w, minY + 0.35709 * h)];
    [path2Path addCurveToPoint:CGPointMake(minX + 0.51837 * w, minY + 0.15221 * h) controlPoint1:CGPointMake(minX + 0.3954 * w, minY + -0.20574 * h) controlPoint2:CGPointMake(minX + 0.27039 * w, minY + 0.40718 * h)];
    [path2Path addCurveToPoint:CGPointMake(minX + 0.75538 * w, minY + 0.07567 * h) controlPoint1:CGPointMake(minX + 0.76635 * w, minY + -0.10276 * h) controlPoint2:CGPointMake(minX + 0.58406 * w, minY + 0.27902 * h)];
    [path2Path addCurveToPoint:CGPointMake(minX + 0.92723 * w, minY + 0.15221 * h) controlPoint1:CGPointMake(minX + 0.80826 * w, minY + 0.0129 * h) controlPoint2:CGPointMake(minX + 0.79998 * w, minY + 0.32178 * h)];
    [path2Path addCurveToPoint:CGPointMake(minX + w, minY + h) controlPoint1:CGPointMake(minX + 0.98487 * w, minY + 0.07541 * h) controlPoint2:CGPointMake(minX + 0.99473 * w, minY + -0.16605 * h)];
    
    return path2Path;
}

- (UIBezierPath*)path3PathWithBounds:(CGRect)bound{
    UIBezierPath *path3Path = [UIBezierPath bezierPath];
    CGFloat minX = CGRectGetMinX(bound), minY = CGRectGetMinY(bound), w = CGRectGetWidth(bound), h = CGRectGetHeight(bound);
    
    [path3Path moveToPoint:CGPointMake(minX + 0.0088 * w, minY + 0.98602 * h)];
    [path3Path addCurveToPoint:CGPointMake(minX + 0.02149 * w, minY + 0.20991 * h) controlPoint1:CGPointMake(minX + -0.00618 * w, minY + 0.67517 * h) controlPoint2:CGPointMake(minX + -0.00209 * w, minY + 0.24285 * h)];
    [path3Path addCurveToPoint:CGPointMake(minX + 0.2628 * w, minY + 0.39086 * h) controlPoint1:CGPointMake(minX + 0.04508 * w, minY + 0.17696 * h) controlPoint2:CGPointMake(minX + 0.12013 * w, minY + 0.6314 * h)];
    [path3Path addCurveToPoint:CGPointMake(minX + 0.54547 * w, minY + 0.39086 * h) controlPoint1:CGPointMake(minX + 0.40546 * w, minY + 0.15031 * h) controlPoint2:CGPointMake(minX + 0.29749 * w, minY + 0.6088 * h)];
    [path3Path addCurveToPoint:CGPointMake(minX + 0.80852 * w, minY + 0.07575 * h) controlPoint1:CGPointMake(minX + 0.79345 * w, minY + 0.17291 * h) controlPoint2:CGPointMake(minX + 0.6372 * w, minY + 0.24957 * h)];
    [path3Path addCurveToPoint:CGPointMake(minX + 0.94199 * w, minY + 0.01943 * h) controlPoint1:CGPointMake(minX + 0.86141 * w, minY + 0.0221 * h) controlPoint2:CGPointMake(minX + 0.81474 * w, minY + 0.16437 * h)];
    [path3Path addCurveToPoint:CGPointMake(minX + w, minY + h) controlPoint1:CGPointMake(minX + 0.99963 * w, minY + -0.04622 * h) controlPoint2:CGPointMake(minX + 0.99473 * w, minY + 0.00329 * h)];
    
    return path3Path;
}

- (UIBezierPath*)rectanglePathWithBounds:(CGRect)bound{
    UIBezierPath *rectanglePath = [UIBezierPath bezierPath];
    CGFloat minX = CGRectGetMinX(bound), minY = CGRectGetMinY(bound), w = CGRectGetWidth(bound), h = CGRectGetHeight(bound);
    
    [rectanglePath moveToPoint:CGPointMake(minX, minY + h)];
    [rectanglePath addLineToPoint:CGPointMake(minX + w, minY + h)];
    [rectanglePath addLineToPoint:CGPointMake(minX + w, minY)];
    [rectanglePath moveToPoint:CGPointMake(minX, minY)];
    [rectanglePath addLineToPoint:CGPointMake(minX, minY + h)];
    
    return rectanglePath;
}


@end